<?php
 
 
 

namespace PhpWA\Protocol\Proto;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class Field extends \Google\Protobuf\Internal\Message
{
    


    protected $minVersion = null;
    


    protected $maxVersion = null;
    


    protected $notReportableMinVersion = null;
    


    protected $isMessage = null;
    


    private $subfield;

    












    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getMinVersion()
    {
        return isset($this->minVersion) ? $this->minVersion : 0;
    }

    public function hasMinVersion()
    {
        return isset($this->minVersion);
    }

    public function clearMinVersion()
    {
        unset($this->minVersion);
    }

    




    public function setMinVersion($var)
    {
        GPBUtil::checkUint32($var);
        $this->minVersion = $var;

        return $this;
    }

    



    public function getMaxVersion()
    {
        return isset($this->maxVersion) ? $this->maxVersion : 0;
    }

    public function hasMaxVersion()
    {
        return isset($this->maxVersion);
    }

    public function clearMaxVersion()
    {
        unset($this->maxVersion);
    }

    




    public function setMaxVersion($var)
    {
        GPBUtil::checkUint32($var);
        $this->maxVersion = $var;

        return $this;
    }

    



    public function getNotReportableMinVersion()
    {
        return isset($this->notReportableMinVersion) ? $this->notReportableMinVersion : 0;
    }

    public function hasNotReportableMinVersion()
    {
        return isset($this->notReportableMinVersion);
    }

    public function clearNotReportableMinVersion()
    {
        unset($this->notReportableMinVersion);
    }

    




    public function setNotReportableMinVersion($var)
    {
        GPBUtil::checkUint32($var);
        $this->notReportableMinVersion = $var;

        return $this;
    }

    



    public function getIsMessage()
    {
        return isset($this->isMessage) ? $this->isMessage : false;
    }

    public function hasIsMessage()
    {
        return isset($this->isMessage);
    }

    public function clearIsMessage()
    {
        unset($this->isMessage);
    }

    




    public function setIsMessage($var)
    {
        GPBUtil::checkBool($var);
        $this->isMessage = $var;

        return $this;
    }

    



    public function getSubfield()
    {
        return $this->subfield;
    }

    




    public function setSubfield($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::UINT32, \Google\Protobuf\Internal\GPBType::MESSAGE, \PhpWA\Protocol\Proto\Field::class);
        $this->subfield = $arr;

        return $this;
    }

}

